OpenCASCADE Make Primitives-Box

eryar@163.com

Abstract. By making a simple box to demonstrate the BRep data structure of the OpenCASCADE. The construction method is different from BRepPrimAPI_MakeBox. In the paper construct the box from vertex, edge to solid, while in BRepPrimAPI_MakeBox from solid, shell to vertex. From the construction, the BRep data structure in OpenCASCADE also can be called the Winged-Edge data structure.

Key Words. OpenCASCADE, BRep, Box, The Winged-Edge Structure

1. Introduction

OpenCASCADE的Toolit TKPrim中提供了基本图元的创建功能,像Box, Cylinder, Sphere等等。直接使用Package BRepPrimAPI中的功能,可以方便地创建出基本图元,而不用关心其内部的数据结构。

Figure 1. BRepPrimAPI Package classes

为 了理解ModelingData模块中OpenCASCADE的边界表示法BRep数据结构,决定参考其实现,自己来创建出基本图元,进而理解其中的 BRep数据结构。本文以最简单的长方体Box入手,从点、边到体的创建出一个形状。并将构造的形状在Draw Test Harness中进行显示,且进行布尔运算,来验证构造结果的正确性。

2.Make a Face of the Box

在OpenCASCADE的包BRepPrim中,构造长方体的方式是形状的根结点出发到叶子结点,即从Shell到Face到Wire最后到Vertex,如下图所示:

Figure 2.1 Data structure of a Shape

为了程序演示的清晰,本文中采用与OpenCASCADE中相反的方式,即先从叶子结点出发,逐步回到根结点,即先构造出顶点、边最后到实体。长方体由六个面构成,所以先从一个面开始来构造。将一个面构造成功后,其他六个面的构造方法就相同了。

构造使用了BRep_Builder,在创建相应的拓朴的同时可以将其相关的几何信息设置进去。如创建顶点Vertex时,可以将点的坐标信息及容差值设置进去,代码如下所示:

BRep_Builder aBuilder;

// make vertex of the box.
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());
aBuilder.MakeVertex(aVertices[], aPoints[], Precision::Confusion());

创建边的同时,将其边中的三维曲线信息也设置进去,代码如下所示:

// make edges of the box.
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion()); aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion()); aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[], new Geom_Line(aLines[]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[],new Geom_Line(aLines[]),Precision::Confusion());
aBuilder.MakeEdge(aEdges[],new Geom_Line(aLines[]),Precision::Confusion());

创建的边Edge还需要与顶点Vertex关联上,且需要注意顶点的反向,示例代码如下所示:

// set the vertex info of the edges.
// edge 0:
{
TopoDS_Vertex V1 = aVertices[];
TopoDS_Vertex V2 = aVertices[]; V2.Reverse(); aBuilder.Add(aEdges[], V1);
aBuilder.Add(aEdges[], V2);   aBuilder.UpdateVertex(V1, ElCLib::Parameter(aLines[], aPoints[]),
   aEdges[], Precision::Confusion());
  aBuilder.UpdateVertex(V2, ElCLib::Parameter(aLines[], aPoints[]),
   aEdges[], Precision::Confusion()); BRepTools::Update(aEdges[]);
}

接着创建Wire,创建Wire时需要注意边的反向,从而构造成一个闭合的Wire,代码如下所示:

// make wires of the box.
aBuilder.MakeWire(aWires[]); // wire 1: bottom
{
TopoDS_Edge E1 = aEdges[];
TopoDS_Edge E2 = aEdges[];
TopoDS_Edge E3 = aEdges[];
TopoDS_Edge E4 = aEdges[]; E3.Reverse();
E4.Reverse(); aBuilder.Add(aWires[], E1);
aBuilder.Add(aWires[], E2);
aBuilder.Add(aWires[], E3);
aBuilder.Add(aWires[], E4); BRepTools::Update(aWires[]);
}

关键是面的创建及面创建后,设置边与面的关联信息,即PCurve的信息。如果没有PCurve的信息,可视化显示就不能正确显示出面,即网格化算法会失败。长方体底面的创建及PCurve设置代码如下所示:

// make faces of the box.
aBuilder.MakeFace(aFaces[],new Geom_Plane(aPlanes[]),Precision::Confusion()); aBuilder.Add(aFaces[], aWires[]); // set bottom pcurve info of between the edge and surface.
{
// pcurve 0:
double u = 0.0;
double v = 0.0;
double du = 0.0;
double dv = 0.0;
gp_Dir DX = aPlanes[].XAxis().Direction();
gp_Dir DY = aPlanes[].YAxis().Direction(); ElSLib::Parameters(aPlanes[], aLines[].Location(), u, v);
du = aLines[].Direction() * DX;
dv = aLines[].Direction() * DY; aBuilder.UpdateEdge(aEdges[], new Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v),
gp_Dir2d(du, dv))), aFaces[], Precision::Confusion());
// pcurve 1:
ElSLib::Parameters(aPlanes[], aLines[].Location(), u, v);
du = aLines[].Direction() * DX;
dv = aLines[].Direction() * DY; aBuilder.UpdateEdge(aEdges[], new Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v),
gp_Dir2d(du, dv))), aFaces[], Precision::Confusion());
// pcurve 2:
ElSLib::Parameters(aPlanes[], aLines[].Location(), u, v);
du = aLines[].Direction() * DX;
dv = aLines[].Direction() * DY; aBuilder.UpdateEdge(aEdges[], new Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v),
gp_Dir2d(du, dv))), aFaces[], Precision::Confusion());
// pcurve 3:
ElSLib::Parameters(aPlanes[], aLines[].Location(), u, v);
du = aLines[].Direction() * DX;
dv = aLines[].Direction() * DY; aBuilder.UpdateEdge(aEdges[], new Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v),
gp_Dir2d(du, dv))), aFaces[], Precision::Confusion());
}

历经艰辛,最后终于将一个面创建出来了,且可以在Draw Test Harness中显示,如下图所示:

Figure 2.2 A Face of the Box in Draw Test Harness

如上图所示,在Darw Test Harness中,边的颜色是有讲究的,说明如下:

In Draw Test Harness, shapes are displayed using isoparametric curves. There is color coding for the Edges:

v A red edge is an isolated edge, which belongs to no faces;

v A green edge is a free boundary edge, which belongs to one face;

v A yello edge is shared edge, which belongs to at least two faces;

Figure 2.3 Color Coding for Edges in Draw Test Harness

如上图所示,红色的边表示此边不属于任何一个面;绿色的边表示此边只属于一个面;黄色的面表示此面至少属于两个面。

Figure 2.4 Shared Edges of the Box

如上图所示,当创建出长方体的三个面时,侧面与上下两个底面相连的边显示成了黄色。其他边都是绿色。

3.Finish the Box

将长方体的六个面按上述方式创建完毕后,需要验证其正确性。于是将生成的数据导出为Brep格式,并与其他基本体进行布尔运算。

当导出的长方体为Shell时进行布尔运算会得到的也是壳体,如下图所示的结果:

Figure 3.1 Box Shell Cut a Cylinder

当导出的长方体为Solid时,若面的方式未正确设置,则布尔运算会失败,如下图所示:

Figure 3.2 Box Solid Cut a Cylinder

如上图所示,长方体与圆柱体的交线都已经计算出来了,但由于面的方向不对,不知道去除哪些面,保留哪些面。

将面的方向正确设置后,导出为Solid,进行布尔运算,结果正确,如下图所示:

Figure 3.3 Box Cut Cylinder

测试用的Tcl脚本代码如下所示:

#
# Tcl script to test the box BRep data.
# eryar@163.com
# 2014-11-16 21:55
# OpenCASCADE6.8.0
#
pload ALL restore d:/box.brep b pcylinder c 1.5 bop b c
bopcut r vdisplay r

4.Conclusion

通过创建基本图元,从而进一步来理解OpenCASCADE中的边界表示BRep的数据结构。需要注意的事项有:

v 创建边时,需要设置边中几何曲线的范围;

v 创建边时,需要设置正确与边相关顶点的方向;

v 创建环时,需要确保环中边的参数曲线PCurve能在参数空间中闭合;

v 创建面后,需要在边中设置与面相关的几何信息;

v 创建体时,需要所有面的方向正确;

注:
最后发现前不久写的一篇文章有误,说OpenCASCADE的BRep不是翼边结构。其实从边出发是可以找到与点、面相关的信息的。因为
OpenCASCADE中拓朴结构中有包含关系,所以顶点信息已经包含在边中了,直接遍历边即可得到与此边相关的顶点信息。所以,这样看来
OpenCASCADE中的BRep表示法也是翼边的数据结构。

原文如下:

边界表示方式比较。因为一般的书籍上都详细重
点描述了边界表示中以为边为核心的翼边数据结构,所以有人想从这方面来给OpenCASCADE中的Brep表示法来给个说法。结合上面的类图可知,从边
出发并不能访问到与这条边相关的其他信息,如顶点的信息。如果硬是想在这里给个名分,倒是从点出发可以找到边及面的几何信息,所以OpenCASCADE
中的Brep表示法应该更像是以点为基础的表示方法。OpenNURBS中通过ON_BrepTrim,可以访问其他的信息,而ON_BrepTrim与
边ON_BrepEdge的意义有些相似,所以应该是以边为核心的翼边结构了。

5. References

1. OpenCASCADE BRep vs. OpenNURBS Brep. OpenCASCADE BRep vs. OpenNURBS BRep

PDF Version and Source Code: OpenCASCADE Make Primitives-Box

OpenCASCADE Make Primitives-Box的更多相关文章

  1. OpenCascade Primitives BRep - Box

    OpenCascade Primitives BRep - Box eryar@163.com Abstract. BRep is short for Boundary Representation. ...

  2. OpenCASCADE Make Primitives-Sphere

    OpenCASCADE Make Primitives-Sphere eryar@163.com Abstract. The sphere is the simplest topology shape ...

  3. OpenCascade Primitives BRep - Sphere

    OpenCascade Primitives BRep - Sphere eryar@163.com Abstract. BRep is short for Boundary Representati ...

  4. OpenCascade Primitives BRep-Cone

    OpenCascade Primitives BRep-Cone eryar@163.com Abstract. BRep is short for Boundary Representation. ...

  5. OpenCascade Primitives BRep-Torus

    OpenCascade Primitives BRep-Torus eryar@163.com Abstract. BRep is short for Boundary Representation. ...

  6. OpenCascade Primitives BRep-Cylinder

    OpenCascade Primitives BRep-Cylinder eryar@163.com Abstract. BRep is short for Boundary Representati ...

  7. A Simple OpenCASCADE Qt Demo-occQt

    A Simple OpenCASCADE Qt Demo-occQt eryar@163.com Abstract. OpenCASCADE have provided the Qt samples ...

  8. OpenCASCADE Shape Location

    OpenCASCADE Shape Location eryar@163.com Abstract. The TopLoc package of OpenCASCADE gives resources ...

  9. OpenCASCADE Camera

    OpenCASCADE Camera eryar@163.com Abstract. OpenCASCADE introduce a new class Graphic3d_Camera for th ...

随机推荐

  1. 页面加载完成后,触发事件——trigger()

    <button id="btn">点击我</button> <div id="test"></div> 如果页面 ...

  2. 自动ftp上传文件脚本

    方法一: echo "open 21.244.88.129 user glxtftp glbzuser bin prompt off cd /glxt/DBINFO lcd /tmp put ...

  3. iOS开发之单元测试

    开始之前 本文侧重讲述如何在iOS程序的开发过程中使用单元测试.使用Xcode自带的OCUnit作为测试框架. 一.单元测试概述 单元测试作为敏捷开发实践的组成之一,其目的是提高软件开发的效率,维持代 ...

  4. python中非关键字可变长参数和关键字变量参数的区别

    #非关键字可变长参数 def add(*arg):    return type(arg) print add() #打印结果 <type 'tuple'> #关键字变量参数 def ab ...

  5. myBatis中 collection 或 association 联合查询 中column 传入多个参数值

    下面是一个树形结构表自连接 联合查询 Demo <resultMap id="BaseResultMap"  type="com.maidan.daas.entit ...

  6. toroiseSVN 无法连接服务器,提示unable connect to ……url 参数错误

    之前使用的好好的,有天突然提示无法连接repository url,能ping通服务器,就是一直报错,找了很多方法,如: 1.删除缓存及缓存文件 2.删除软件并重新安装 3.关闭windows防火墙 ...

  7. CSS外边距叠加问题

    CSS外边距叠加就是margin-collapse,边距合并指的是,当两个垂直外边距相遇时,它们将形成一个外边距,水平边 距永远不会重合.重叠结果计算规则:①.两个相邻的外边距都是正数时,折叠结果是它 ...

  8. android布局实践——模仿微信主界面

    这是目前微信6.0版本的主界面 先来分析一波: 1.(top.xml)界面头部有一个微信(6)消息提醒    一个搜索图标   一个更多的的图标+,中间还有一段空白,我们可以弄两个textView(其 ...

  9. 通过反射获取DLL的类实现加载窗体

    1.创建一个DLL 类库,并新建一个窗体类,这个直接在vs上操作就好 2. 建立一个Testassembly工程 新建一个测试类 namespace Testassembly { public par ...

  10. 有了lisk,为什么我们还要做一个Asch?

    0 前言 首先要声明一点,我们和我们的一些朋友都是lisk的投资人和支持者,我们也相信lisk会成功. 事实上,lisk已经成功了一半,目前在区块链领域融资金额排行第二,仅次于以太坊. 那为什么我们还 ...